# -*- coding: iso-8859-1 -*-
from lxml import etree
import urllib
import urllib2

# Searcher class
class HundraArtonEttHundra:
    def __init__(self, page_size):
        self.url = 'http://developer.118100.se:8080/openapi/appetizing?query='
        self.xml = None
        self.page_size = page_size
        self.person_results = []

    def do_search(self, query_string):
        req = urllib2.Request(self.url+urllib.quote(query_string)+'&pageSize='+str(self.page_size))
        res = urllib2.urlopen(req)
        rawXml = res.read()

        self.xml = etree.fromstring(rawXml)
        #print result.value

        self.person_results = self.parse_result('personHits')

    def parse_result(self, search_type):
        hits = self.xml.findall('.//'+search_type)[0]
        hitlist = []
        for hit in hits:
            res = HundraArtonEttHundraResult()
            res.itesco_id = hit.get('itescoid')
            if search_type == 'personHits':
                try:
                    res.person_number = hit.find('.//individual/personNumber').text
                except:
                    pass

            # Fetch names
            try:
                for name in hit.findall('.//name'):
                    temp_name = HundraArtonEttHundraName()
                    temp_name.type = name.get('type')
                    temp_name.name = name.text
                    res.names.append(temp_name)
            except:
                pass
            
            # Address
            for addr in hit.findall('.//address'):
                ad = HundraArtonEttHundraAddress()
                try:
                    ad.street = addr.find('.//street/name').text
                except:
                    pass
                try:
                    ad.number = addr.find('.//street/number').text
                except:
                    pass
                try:
                    ad.zip = addr.find('.//zip').text
                except:
                    pass
                try:
                    ad.city = addr.find('.//city').text
                except:
                    pass
                res.addresses.append(ad)

            # Phone numbers
            for num in hit.findall('.//phone_number'):
                number = HundraArtonEttHundraTelephone()
                try:
                    number.international_prefix = num.find('.//internationalPrefix').text
                except:
                    pass
                try:
                    number.area_code = num.find('.//areaCode').text
                except:
                    pass
                try:
                    number.local_number = num.find('.//localNumber').text
                except:
                    pass
                try:
                    number.type = num.get('type')
                except:
                    pass
                res.phone_numbers.append(number)
            # Additional info
            for add in hit.findall('.//teleAddress'):
                tele_address = HundraArtonEttHundraTeleAddress()
                try:
                    tele_address.type = add.get('type')
                    tele_address.name = add.text
                    res.tele_address.append(tele_address)
                except:
                    pass
            
            hitlist.append(res)
        return(hitlist)

# Result set class
class HundraArtonEttHundraResult:
    def __init__(self):
        self.itesco_id = None

        self.type = None # either 'person' or 'company'
   
        self.person_number = None
        self.organisation_number = None

        self.names = []

        # Phone numbers
        self.phone_numbers = []

        # Address
        self.addresses = []

        # Coordinates
        self.coord_x = None
        self.coord_y = None

        # Tele address
        self.tele_address = []

class HundraArtonEttHundraAddress:
    def __init__(self):
        self.street = None
        self.number = None
        self.zip = None
        self.city = None

class HundraArtonEttHundraTelephone:
    def __init__(self):
        self.type = None
        self.international_prefix = None
        self.area_code = None
        self.local_number = None

class HundraArtonEttHundraName:
    def __init__(self):
        self.type = None
        self.name = None

class HundraArtonEttHundraTeleAddress:
    def __init__(self):
        self.type = None
        self.address = None
